<template>
    <div class="notes">
        <div
            class="note"
            :class="[{ full: !grid }, setStatusColor(note.status)]"
            v-for="(note, index) in notes"
            :key="index"
        >
            <div class="note-header" :class="{ full: !grid }">
                <p>{{ note.title }}</p>
                <p style="cursor: pointer;" @click="removeNote(index)">X</p>
            </div>
            <div class="note-body">
                <p>{{ note.description }}</p>
                <span>{{ note.date }}</span>
            </div>
            <hr />
        </div>
    </div>
</template>

<script>
export default {
    props: {
        notes: {
            type: Array,
            required: true,
        },
        grid: {
            type: Boolean,
            required: true,
        },
    },
    methods: {
        removeNote(index) {
            this.$emit('remove', index)
            console.log(`Note with index ${index} is removed!`)
        },
        setStatusColor(status) {
            switch (status) {
                case 1:
                    return { 'status-warning': true }
                case 2:
                    return { 'status-danger': true }
                default:
                    return { 'status-normal': true }
            }
        },
    },
}
</script>

<style lang="scss">
@import '@/assets/scss/utils/vars.scss';
.status-normal {
    border: 2px solid $light-color;
}
.status-warning {
    border: 2px solid $warning-color;
}
.status-danger {
    border: 2px solid $danger-color;
}
.notes {
    display: flex;
    align-items: center;
    justify-content: space-between;
    flex-wrap: wrap;
    padding: 40px 0;
}
.note {
    width: 46%;
    padding: 18px 20px;
    margin-bottom: 20px;
    background-color: #fff;
    transition: all 0.25s cubic-bezier(0.02, 0.01, 0.47, 1);
    box-shadow: 0 30px 30px rgba(0, 0, 0, 0.02);
    &:hover {
        box-shadow: 0 30px 30px rgba(0, 0, 0, 0.04);
        transform: translate(0, -6px);
        transition-delay: 0s !important;
    }
    &.full {
        width: 100%;
        text-align: center;
    }
}
.flex-block {
    display: flex;
    align-items: center;
    justify-content: space-between;
    flex-wrap: wrap;
}
.note-header {
    display: flex;
    align-items: center;
    justify-content: space-between;
    flex-wrap: wrap;
    h1 {
        font-size: 32px;
    }
    p {
        color: #402caf;
        font-size: 22px;
    }
    svg {
        margin-right: 12px;
        color: #999999;
        &.active {
            color: #402caf;
        }
        &:last-child {
            margin-right: 1px;
        }
    }
    &.full {
        justify-content: center;
        p {
            margin-right: 16px;
            &:last-child {
                margin-right: 0;
            }
        }
    }
}
.note-body {
    p {
        margin: 20px 0;
    }
    span {
        font-size: 14px;
        color: #999999;
    }
}
</style>
